"-----------------------------------------------------------------------------
"
" Filename:      keys.vim
" Author:        Helmut Kolb - koh
"
" Last modified: Wednesday, 05 January 2005 - 10:33
"
" History:       Creation on Friday, 17 November 2000 - 12:49
"
"-----------------------------------------------------------------------------

" -=> abkuerzungen
" umlaute
iab  
iab  
iab  
iab  

" -=> mappings
" mappings fuer tagging des markierten bereichs
vmap \tag c<TAG><C-R>"</TAG>
vmap ,tag c<Esc>:call Tag(input("tag: "))<CR>

" blockquote
vmap ,block :call VBlockquote(input("Title: "))<CR>

" make mittels F2
noremap <F2> :silent! make -k<CR>

" grep mittels C-F2
vnoremap <C-F2> y:call MyGrep("-i","<C-r>"",input("Files: "))<CR>
nnoremap <C-F2> :call MyGrep("-i",expand("<cword>"),input("Files: "))<CR>
inoremap <C-F2> :call MyGrep("-i",expand("<cword>"),input("Files: "))<CR>
" im eterm auch
vnoremap [12^ y:call MyGrep("-i","<C-r>"",input("Files: "))<CR>
nnoremap [12^ :call MyGrep("-i",expand("<cword>"),input("Files: "))<CR>
inoremap [12^ :call MyGrep("-i",expand("<cword>"),input("Files: "))<CR>

" zu der fundstelle des ausdruckes unter dem cursor springen
nnoremap <F4> [I:let nr = input("Which one: ")<Bar>exe "normal " . nr ."[\t"<CR>

" dec/hex umrechnungen (S-F4/C-F4)
inoremap <S-F4> <C-R>=Dec2Hex(input("Dec: "))<CR>
inoremap <C-F4> <C-R>=Hex2Dec(input("Hex: "))<CR>
" im eterm auch
inoremap [26~ <C-R>=Dec2Hex(input("Dec: "))<CR>
inoremap [14^ <C-R>=Hex2Dec(input("Hex: "))<CR>

" den aktuellen buffer als (colored) html speichern (F5)
nnoremap <F5> :source $VIMRUNTIME/syntax/2html.vim<CR>

" anzeige von ergebnissen
nnoremap <F7> :cnext<CR>
nnoremap <F8> :cprevious<CR>

" buffer umschalten/loeschen (epm war schon toll...)
inoremap <F10> <Esc>:bdelete<CR>i
nnoremap <F10> :bdelete<CR>
vnoremap <F10> <Esc>:bdelete<CR>v
inoremap <F11> <Esc>:bprevious<CR>i
nnoremap <F11> :bprevious<CR>
vnoremap <F11> <Esc>:bprevious<CR>v
inoremap <F12> <Esc>:bnext<CR>i
nnoremap <F12> :bnext<CR>
vnoremap <F12> <Esc>:bnext<CR>v

" buffer umschalten
noremap <C-n> <C-w>w

" einen tag im preview window anzeigen
noremap <C-h> :exec "ptag " . expand("<cword>")<CR>

" -=> besondere mappings
" source-file
function SourceMappings()
  " programmierungen (das duerfte als mapping besser sein...)
  "iab todo /*<CR>TODO :<CR>koh - <C-R>=system( 'date "+%A, %d %B %H:%M"' )<CR><BS><BS>*/<Up><Up><End>
  " mein kommentar
  inoremap  ,koh <Space>- koh, <C-R>=system( 'echo -n `date +%Y-%m-%d`' )<CR>) */
  " tab mit autoindent
  nnoremap <Tab> ==
  inoremap <Tab> <C-O>==
  " zwischen c und h files umschalten
  nmap ,source :call ToggleSourceHeader("e")<CR>
  noremap <F9> :call ToggleSourceHeader("e")<CR>
  noremap [20~ :call ToggleSourceHeader("e")<CR>
  " mappings auf normale tasten (ausschaltbar-S-C-F2) - klammern,...
  inoremap <S-C-F2> <Esc>:call SourceReMap(0)<CR>a
  " im eterm auch
  inoremap [24^ <Esc>:call SourceReMap(0)<CR>a
  call SourceReMap(1)
  call SourceReMap(0)
  " make und grep funktionen
  vnoremap ,grep y:call MyGrep("-i","<C-r>"","*.c *.C *.cpp *.h *.H *.asm")<CR>
  nnoremap ,grep :call MyGrep("-i",expand("<cword>"),"*.c *.C *.cpp *.h *.H *.asm")<CR>
  nnoremap ,make :make<CR>
endfunction
function SourceReMap(switch)
  if a:switch
    "set autoindent
    "set cindent
    inoremap {    {}<Esc>i
    inoremap [    []<Esc>i
    inoremap (    ()<Esc>i
    inoremap ; ;<Esc>==A<CR>
    iunmap <S-C-F2>
    inoremap <S-C-F2> <Esc>:call SourceReMap(0)<CR>a
    " im eterm auch
    iunmap [24^
    inoremap [24^ <Esc>:call SourceReMap(0)<CR>a
  else
    "set noautoindent
    "set nocindent
    iunmap {
    iunmap [
    iunmap (
    iunmap ;
    iunmap <S-C-F2>
    inoremap <S-C-F2> <Esc>:call SourceReMap(1)<CR>a
    " im eterm auch
    iunmap [24^
    inoremap [24^ <Esc>:call SourceReMap(1)<CR>a
  endif
endfunction

" php sourcen
function PHPMappings()
  call SourceMappings()
  " per f3 aus normalem html einen php print machen
  nnoremap <F3> :s/$/"/<C-M>:s/\"/\\\"/g<C-M>:s/..$//<C-M>Iprint("<Esc>A\n");<Esc>
endfunction

