"-----------------------------------------------------------------------------
"
" Filename:      settings.vim
" Author:        Helmut Kolb - koh
"
" Last modified: Wednesday, 05 January 2005 - 10:26
"
" History:       Creation on Friday, 17 November 2000 - 12:49
"
"-----------------------------------------------------------------------------

" suchergebnisse farbig hinterlegen
set hlsearch

" fenstertitle fuer das xterm
set title titlestring=%=%F

" ist normalerweise so
set background=dark

" syntaxhilighting ist super
if has("syntax")
  syntax on             " Default to no syntax highlightning 
endif

" text der statusline
set statusline=%9*[%n]%6*\ %{getcwd()}\ -\ %F\ %2*%m%R%H%W%Y\ %3*%b\/%B%=%1*\ %{Options()}\ %5*<%l\/%L,%c%V\ %P>%4*\ %7*%{strftime(\"%Y/%m/%d\ %H:%M\\")}%1*\ 
set laststatus=2
set ruler

" farbgebung der statusline
hi User1 term=inverse,bold cterm=bold ctermfg=blue    gui=bold guifg=blue
hi User2 term=inverse,bold cterm=bold ctermfg=red     gui=bold guifg=red
hi User3 term=inverse,bold cterm=bold ctermfg=magenta gui=bold guifg=magenta
hi User4 term=inverse,bold cterm=bold ctermfg=green   gui=bold guifg=green
hi User5 term=inverse,bold cterm=bold ctermfg=cyan    gui=bold guifg=cyan
hi User6 term=inverse,bold cterm=bold ctermfg=yellow  gui=bold guifg=yellow
hi User7 term=inverse,bold cterm=inverse,bold ctermfg=blue gui=bold guibg=blue
hi User8 term=inverse,bold cterm=inverse,bold ctermfg=red gui=bold guibg=red
hi User9 term=inverse,bold cterm=inverse,bold ctermfg=green gui=bold guibg=green

" was wir alles abspeichern
" % - buffer list
" ' - anzahl files dessen marks gespeichert werden
" " - anzahl der registerzeilen
" : - anzahl der kommandozeilen
" n - name des files
set viminfo=%,'50,\"100,:100,n~/.viminfo

" schaut besser aus.
set shiftwidth=2

" mittels <C-U> und <C-D> jeweils eine zeile scrollen
set scroll=1

" tabstops als spaces einfuegen
set expandtab

" ich will nix wissen
set verbose=0

" netteres folding
set foldtext=/^.*$/\\d\ -------------------------\ \\f\ Lines\ 

" damit eine vim-shell auch erkennbar ist
let $PS1="VIM: \\u@\\h:\\w\\\\$ "

" buffers bei make,... vorher speichern
set autowrite

" backups machen, aber nicht ueberall herumliegen lassen
set backup
set backupdir=~/temp/vimbackup/
set backupext=.bak

" syntax highlighting perfect halten
syntax sync fromstart

" cursor bei scroll operationen in der selben spalte lassen
set nostartofline

" suchen smart gestalten (wenn upper dann case sensitive)
set smartcase

" eine zeile zusaetzlich fuer flist
set cmdheight=2

" damit die buffer, beim switch nicht gespeichert werden _muessen_
set hidden

